Package org.kie.api.management

## Interface GenericKieSessionMonitoringMXBean

- All Known Subinterfaces:
    `KieSessionMonitoringMXBean`, `StatelessKieSessionMonitoringMXBean`

      public interface GenericKieSessionMonitoringMXBean

  An MBean interface for `KieSession` monitoring

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static interface` | `GenericKieSessionMonitoringMXBean.IAgendaStatsData` |
    `static interface` | `GenericKieSessionMonitoringMXBean.IGlobalProcessStatsData` |
    `static interface` | `GenericKieSessionMonitoringMXBean.IProcessStatsData` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `double` | `getAverageFiringTime()` |
    `String` | `getKieBaseId()` |
    `String` | `getKieSessionName()` |
    `Date` | `getLastReset()` |
    `ObjectName` | `getName()` | Returns this MBean name
    `Map<String,​GenericKieSessionMonitoringMXBean.IProcessStatsData>` | `getStatsByProcess()` |
    `Map<String,​GenericKieSessionMonitoringMXBean.IAgendaStatsData>` | `getStatsByRule()` |
    `GenericKieSessionMonitoringMXBean.IProcessStatsData` | `getStatsForProcess​(String processId)` |
    `GenericKieSessionMonitoringMXBean.IAgendaStatsData` | `getStatsForRule​(String ruleName)` | Returns the statistics for a single rule in this session, like number of matches created, cancelled and fired as well as firing time.
    `long` | `getTotalFiringTime()` |
    `long` | `getTotalMatchesCancelled()` |
    `long` | `getTotalMatchesCreated()` |
    `long` | `getTotalMatchesFired()` |
    `long` | `getTotalProcessInstancesCompleted()` |
    `long` | `getTotalProcessInstancesStarted()` |
    `long` | `getTotalSessions()` | Return the total number of KieSession monitored by name by this MBean.
    `void` | `reset()` | Resets all stats

- - ### Method Detail

    - #### reset

          void reset()

      Resets all stats

    - #### getName

          ObjectName getName()

      Returns this MBean name

    - #### getKieBaseId

          String getKieBaseId()

      Returns:
        the associated Kie Base ID

    - #### getTotalMatchesFired

          long getTotalMatchesFired()

      Returns:
        the total number of matches fired in this session since last reset.

    - #### getTotalMatchesCancelled

          long getTotalMatchesCancelled()

      Returns:
        the total number of matches cancelled in this session since last reset.

    - #### getTotalMatchesCreated

          long getTotalMatchesCreated()

      Returns:
        the total number of matches created in this session since last reset.

    - #### getTotalFiringTime

          long getTotalFiringTime()

      Returns:
        the total milliseconds spent firing rules in this session since last reset.

    - #### getAverageFiringTime

          double getAverageFiringTime()

      Returns:
        the average firing time in milliseconds for rules in this session since last reset.

    - #### getLastReset

          Date getLastReset()

      Returns:
        the timestamp of the last stats reset

    - #### getStatsForRule

          GenericKieSessionMonitoringMXBean.IAgendaStatsData getStatsForRule​(String ruleName)

      Returns the statistics for a single rule in this session, like number of matches created, cancelled and fired as well as firing time.
      Parameters:
        `ruleName` - the name of the rule for which statistics are requested.
      Returns:
        the statistics for a single rule in this session

    - #### getStatsByRule

          Map<String,​GenericKieSessionMonitoringMXBean.IAgendaStatsData> getStatsByRule()

    - #### getTotalProcessInstancesStarted

          long getTotalProcessInstancesStarted()

    - #### getTotalProcessInstancesCompleted

          long getTotalProcessInstancesCompleted()

    - #### getStatsForProcess

          GenericKieSessionMonitoringMXBean.IProcessStatsData getStatsForProcess​(String processId)

    - #### getStatsByProcess

          Map<String,​GenericKieSessionMonitoringMXBean.IProcessStatsData> getStatsByProcess()

    - #### getKieSessionName

          String getKieSessionName()

    - #### getTotalSessions

          long getTotalSessions()

      Return the total number of KieSession monitored by name by this MBean. If the type of KieSession monitored is Stateful, this is the total count of Stateful KieSession(s) currently live under the specified KieSession name. If the type of KieSession monitored is Stateless, this is the total amount of Working Memory created.